varying highp vec2 textureCoordinate;
precision highp float;
uniform sampler2D videoFrame;
uniform sampler2D supTex1;
uniform sampler2D supTex2;
uniform sampler2D supTex3;
uniform sampler2D supTex4;
uniform sampler2D supTex5;

vec3 colorsCorrection(vec3 base) {
    highp vec2 lookup;
    base.r = base.r * 0.95 + 0.025;
    lookup.y = base.g;
    lookup.x = (base.r + floor(base.b * 15.0 + 0.50)) / 16.0;
    base.rgb = texture2D(supTex1, lookup).rgb;
    return base;
}

vec3 colorDodgeFill(vec3 blend, float fill) {
    return (blend - (blend) * (1.0 - fill));
}

void main() {
    highp vec4 color;
    highp vec4 c2;
    highp vec4 c3;
    highp vec4 c4;
    highp vec4 c5;
    vec2 tileCoord = mod(floor(textureCoordinate * 640.0), 128.0) / 128.0;
    color = texture2D(videoFrame, textureCoordinate);
    color.rgb = colorsCorrection(color.rgb);
    c2 = texture2D(supTex2, tileCoord);
    color.rgb = mix(color.rgb, vec3(((c2.r < 0.5) ? (2.0 * color.r * c2.r + color.r * color.r * (1.0 - 2.0 * c2.r)) : (sqrt(color.r) * (2.0 * c2.r - 1.0) + 2.0 * color.r * (1.0 - c2.r))), ((c2.g < 0.5) ? (2.0 * color.g * c2.g + color.g * color.g * (1.0 - 2.0 * c2.g)) : (sqrt(color.g) * (2.0 * c2.g - 1.0) + 2.0 * color.g * (1.0 - c2.g))), ((c2.b < 0.5) ? (2.0 * color.b * c2.b + color.b * color.b * (1.0 - 2.0 * c2.b)) : (sqrt(color.b) * (2.0 * c2.b - 1.0) + 2.0 * color.b * (1.0 - c2.b)))), c2.a);
    c3 = texture2D(supTex3, tileCoord);
    c3.rgb = colorDodgeFill(c3.rgb, 0.50);
    color.rgb = vec3(((c3.r == 1.0) ? c3.r : min(color.r / (1.0 - c3.r), 1.0)), ((c3.g == 1.0) ? c3.g : min(color.g / (1.0 - c3.g), 1.0)), ((c3.b == 1.0) ? c3.b : min(color.b / (1.0 - c3.b), 1.0)));
    c4 = texture2D(supTex4, textureCoordinate);
    color.rgb = mix(color.rgb, (c4.rgb), c4.a);
    c5 = texture2D(supTex5, textureCoordinate);
    color.rgb = mix(color.rgb, vec3(max(c5.r, color.r), max(c5.g, color.g), max(c5.b, color.b)), c5.a);
    gl_FragColor = color;
}
