varying highp vec2 textureCoordinate;
precision highp float;
uniform sampler2D videoFrame;
uniform sampler2D supTex1;
uniform sampler2D supTex2;
uniform sampler2D supTex3;
uniform sampler2D supTex4;
uniform sampler2D supTex5;

vec3 colorsCorrection(vec3 base) {
    highp vec2 lookup;
    base.r = base.r * 0.95 + 0.025;
    lookup.y = base.g;
    lookup.x = (base.r + floor(base.b * 15.0 + 0.50)) / 16.0;
    base.rgb = texture2D(supTex1, lookup).rgb;
    return base;
}

vec3 colorDodgeFill(vec3 blend, float fill) {
    return (blend - (blend) * (1.0 - fill));
}

void main() {
    highp vec4 color;
    highp vec4 c2;
    color = texture2D(videoFrame, textureCoordinate);
    color.rgb = colorsCorrection(color.rgb);
    c2 = texture2D(supTex2, textureCoordinate);
    c2.rgb = colorDodgeFill(c2.rgb, 0.07);
    color.rgb = vec3(((c2.r == 1.0) ? c2.r : min(color.r / (1.0 - c2.r), 1.0)), ((c2.g == 1.0) ? c2.g : min(color.g / (1.0 - c2.g), 1.0)), ((c2.b == 1.0) ? c2.b : min(color.b / (1.0 - c2.b), 1.0)));
    gl_FragColor = color;
}
