varying highp vec2 textureCoordinate;
precision highp float;
uniform sampler2D videoFrame;
uniform sampler2D supTex1;
uniform sampler2D supTex2;
uniform sampler2D supTex3;
uniform sampler2D supTex4;
uniform sampler2D supTex5;

vec3 colorsCorrection(vec3 base) {
    highp vec2 lookup;
    base.r = base.r * 0.95 + 0.025;
    lookup.y = base.g;
    lookup.x = (base.r + floor(base.b * 15.0 + 0.50)) / 16.0;
    base.rgb = texture2D(supTex1, lookup).rgb;
    return base;
}

void main() {
    highp vec4 color;
    highp vec4 c2;
    color = texture2D(videoFrame, textureCoordinate);
    color.rgb = colorsCorrection(color.rgb);
    c2 = texture2D(supTex2, textureCoordinate);
    color.rgb = mix(color.rgb, vec3(max(c2.r, color.r), max(c2.g, color.g), max(c2.b, color.b)), c2.a);
    gl_FragColor = color;
}
