uniform sampler2D videoFrame;
uniform float width;
varying highp vec2 textureCoordinate;

int lineRadius(int i) {
  if (i == 0 || i == 4)
    return 1;
  else
    return 2;
}
void main() {
    vec2 iResolution = vec2(width, width);
    highp vec3 base;
    float gray1, gray2;
    float radius = 2.0;
    float threshold = 20.0;
    float softness = 0.5;
    float strength = 1.0;
    float lowerThreshold = threshold * (1.0 - softness);
    float upperThreshold = threshold * (1.0 + softness);
    float thresholdRange = 2.0 * threshold * softness;
    float width = iResolution.x;
    float height = iResolution.y;
    float delta = 1.0 / width;
    vec3 weight = vec3(0.299, 0.587, 0.114);

    base = texture2D(videoFrame, textureCoordinate).rgb;

    gray1 = dot(base, weight);
    vec3 tmpSum = vec3(0.0);
    float count = 0.0;

    for (highp int i = 0; i < 5; i++){
        for (highp int j = 0; j < 2 * lineRadius(i) + 1; j++){
            float x, y;
            y = float(i - 2);
            x = float(j - lineRadius(i));

            vec3 tmp = texture2D(videoFrame, textureCoordinate + vec2(delta * x, delta * y)).rgb;
            gray2 = dot(tmp, weight);
            float grayDelta = abs(gray1 - gray2);
            float diff = base.r * weight.r + base.r * weight.g + base.b * weight.b -
            (tmp.r * weight.r + tmp.g * weight.g + tmp.b * weight.b);
            diff = sqrt(diff);
            float weight = 1.0;
            if (diff > lowerThreshold) {
                weight = (upperThreshold - diff) / thresholdRange;
            }
            tmpSum += tmp * weight;
            count += weight;
        }
    }
    gl_FragColor = vec4(tmpSum / count, 1.0);
}