varying highp vec2 textureCoordinate;
precision highp float;
uniform sampler2D videoFrame;
uniform sampler2D supTex1;
uniform sampler2D supTex2;
uniform sampler2D supTex3;

vec3 colorsCorrection(vec3 base) {
    highp vec2 lookup;

    base.r = base.r * 0.9 + 0.05;
    lookup.y = base.g;
    lookup.x = (base.r + floor(base.b * 15.0 + 0.50)) / 16.0;
    base.rgb = texture2D(supTex1, lookup).rgb;
    return base;
}

void main() {
    highp vec4 color;
    highp vec4 c2;
    highp vec4 c3;
    color = texture2D(videoFrame, textureCoordinate);
    color.rgb = colorsCorrection(color.rgb);
    c2 = texture2D(supTex2, textureCoordinate);
    color.rgb = mix(color.rgb, vec3(max(min(color.r + 2.0 * c2.r - 1.0, 1.0), 0.0), max(min(color.g + 2.0 * c2.g - 1.0, 1.0), 0.0), max(min(color.b + 2.0 * c2.b - 1.0, 1.0), 0.0)), 0.20);
    gl_FragColor = color;
}
