varying highp vec2 textureCoordinate;
precision highp float;
uniform sampler2D videoFrame;
uniform sampler2D supTex1;
uniform sampler2D supTex2;
uniform sampler2D supTex3;
uniform sampler2D supTex4;

vec3 colorsCorrection(vec3 base) {
    highp vec2 lookup;

    base.r = base.r * 0.9 + 0.05;
    lookup.y = base.g;
    lookup.x = (base.r + floor(base.b * 15.0 + 0.50)) / 16.0;
    base.rgb = texture2D(supTex1, lookup).rgb;
    return base;
}

void main() {
    highp vec4 color;
    highp vec4 temp;
    color = texture2D(videoFrame, textureCoordinate);
    color.rgb = colorsCorrection(color.rgb);
    temp = texture2D(supTex2, textureCoordinate);
    color.rgb = mix(color.rgb, vec3((color.r < 0.5 ? (2.0 * color.r * temp.r) : (1.0 - 2.0 * (1.0 - color.r) * (1.0 - temp.r))), (color.g < 0.5 ? (2.0 * color.g * temp.g) : (1.0 - 2.0 * (1.0 - color.g) * (1.0 - temp.g))), (color.b < 0.5 ? (2.0 * color.b * temp.b) : (1.0 - 2.0 * (1.0 - color.b) * (1.0 - temp.b)))), temp.a);
    temp = texture2D(supTex3, textureCoordinate);
    color.rgb = mix(color.rgb, vec3((color.r < 0.5 ? (2.0 * color.r * temp.r) : (1.0 - 2.0 * (1.0 - color.r) * (1.0 - temp.r))), (color.g < 0.5 ? (2.0 * color.g * temp.g) : (1.0 - 2.0 * (1.0 - color.g) * (1.0 - temp.g))), (color.b < 0.5 ? (2.0 * color.b * temp.b) : (1.0 - 2.0 * (1.0 - color.b) * (1.0 - temp.b)))), temp.a);
    temp = texture2D(supTex4, textureCoordinate);
    color.rgb = mix(color.rgb, vec3((color.r < 0.5 ? (2.0 * color.r * temp.r) : (1.0 - 2.0 * (1.0 - color.r) * (1.0 - temp.r))), (color.g < 0.5 ? (2.0 * color.g * temp.g) : (1.0 - 2.0 * (1.0 - color.g) * (1.0 - temp.g))), (color.b < 0.5 ? (2.0 * color.b * temp.b) : (1.0 - 2.0 * (1.0 - color.b) * (1.0 - temp.b)))), temp.a);
    gl_FragColor = color;
}
