varying highp vec2 textureCoordinate;
precision highp float;
uniform sampler2D videoFrame;
uniform sampler2D supTex1;

vec3 colorsCorrection(vec3 base) {
    highp vec2 lookup;
    base.r = base.r * 0.9 + 0.05;
    lookup.y = base.g;
    lookup.x = (base.r + floor(base.b * 15.0 + 0.50)) / 16.0;
    base.rgb = texture2D(supTex1, lookup).rgb;
    return base;
}

void main() {
    highp vec4 color;
    highp vec4 temp;
    color = texture2D(videoFrame, textureCoordinate);
    color.rgb = colorsCorrection(color.rgb);
    temp = vec4(0.98046875, 0.29296875, 0.32421875, 0.48);
    color.rgb = mix(color.rgb, vec3(max(temp.r, color.r), max(temp.g, color.g), max(temp.b, color.b)), temp.a);
    gl_FragColor = color;
}