varying highp vec2 textureCoordinate;
precision highp float;
uniform sampler2D videoFrame;
uniform sampler2D supTex1;
uniform sampler2D supTex2;

vec3 colorsCorrection(vec3 base) {
    highp vec2 lookup;

    base.r = base.r * 0.9 + 0.05;
    lookup.y = base.g;
    lookup.x = (base.r + floor(base.b * 15.0 + 0.50)) / 16.0;
    base.rgb = texture2D(supTex1, lookup).rgb;
    return base;
}

vec3 colorBurnFill(vec3 blend, float fill) {
    return (blend + (1.0 - blend) * (1.0 - fill));
}

void main() {
    highp vec4 color;
    highp vec4 temp;
    color = texture2D(videoFrame, textureCoordinate);
    color.rgb = colorsCorrection(color.rgb);
    temp = texture2D(supTex2, textureCoordinate);
    temp.rgb = colorBurnFill(temp.rgb, 0.50);
    color.rgb = vec3(((temp.r == 0.0) ? temp.r : max((1.0 - ((1.0 - color.r) / temp.r)), 0.0)), ((temp.g == 0.0) ? temp.g : max((1.0 - ((1.0 - color.g) / temp.g)), 0.0)), ((temp.b == 0.0) ? temp.b : max((1.0 - ((1.0 - color.b) / temp.b)), 0.0)));
    gl_FragColor = color;
}
