varying highp vec2 textureCoordinate;
precision highp float;
uniform sampler2D videoFrame;
uniform sampler2D supTex1;

vec3 colorsCorrection(vec3 base) {
    vec2 lookup;
    vec4 texel;
    texel = vec4(1.0);
    lookup.y = .5;
    lookup.x = base.r;
    texel.r = texture2D(supTex1, lookup).r;
    lookup.x = base.g;
    texel.g = texture2D(supTex1, lookup).g;
    lookup.x = base.b;
    texel.b = texture2D(supTex1, lookup).b;
    return texel.rgb;
}

void main() {
    vec4 base;
    vec3 tmp;
    base = texture2D(videoFrame, textureCoordinate);
    tmp = sqrt(base.rgb);
    base.rgb = mix(base.rgb, tmp, 0.6);
    base.rgb = colorsCorrection(base.rgb);
    vec4 overlay = vec4(0.2745, 0.2078, 0.1725, 0.51);
    tmp.r = overlay.a * base.a - 2.0 * (base.a - base.r) * (overlay.a - overlay.r) + overlay.r * (1.0 - base.a) + base.r * (1.0 - overlay.a);
    tmp.g = 2.0 * overlay.g * base.g + overlay.g * (1.0 - base.a) + base.g * (1.0 - overlay.a);
    tmp.b = 2.0 * overlay.b * base.b + overlay.b * (1.0 - base.a) + base.b * (1.0 - overlay.a);
    base.rgb = mix(base.rgb, tmp, overlay.a);
    overlay = vec4(0.6549, 0.37254, 0.1921, 0.54);
    tmp.r = sqrt(base.r) * (2.0 * overlay.r - 1.0) + 2.0 * base.r * (1.0 - overlay.r);
    tmp.g = 2.0 * base.g * overlay.g + base.g * base.g * (1.0 - 2.0 * overlay.g);
    tmp.b = 2.0 * base.b * overlay.b + base.b * base.b * (1.0 - 2.0 * overlay.b);
    base.rgb = mix(base.rgb, tmp, overlay.a);
    gl_FragColor = base;
}