varying highp vec2 textureCoordinate;
precision highp float;
uniform sampler2D videoFrame;
uniform sampler2D supTex1;
uniform sampler2D supTex2;
uniform sampler2D supTex3;
uniform sampler2D supTex4;
vec3 colorsCorrection(vec3 base) {
    highp vec2 lookup;
    base.r = base.r * 0.9 + 0.05;
    lookup.y = base.g;
    lookup.x = (base.r + floor(base.b * 15.0 + 0.50)) / 16.0;
    base.rgb = texture2D(supTex1, lookup).rgb;
    return base;
}

void main() {
    highp vec4 color;
    highp vec4 c2;
    highp vec4 c3;
    highp vec4 c4;
    color = texture2D(videoFrame, textureCoordinate);
    color.rgb = colorsCorrection(color.rgb);
    c2 = texture2D(supTex2, textureCoordinate);
    color.rgb = mix(color.rgb, vec3((color.r < 0.5 ? (2.0 * color.r * c2.r) : (1.0 - 2.0 * (1.0 - color.r) * (1.0 - c2.r))), (color.g < 0.5 ? (2.0 * color.g * c2.g) : (1.0 - 2.0 * (1.0 - color.g) * (1.0 - c2.g))), (color.b < 0.5 ? (2.0 * color.b * c2.b) : (1.0 - 2.0 * (1.0 - color.b) * (1.0 - c2.b)))), c2.a);
    c3 = texture2D(supTex3, textureCoordinate);
    color.rgb = mix(color.rgb, vec3(max(min(color.r + 2.0 * c3.r - 1.0, 1.0), 0.0), max(min(color.g + 2.0 * c3.g - 1.0, 1.0), 0.0), max(min(color.b + 2.0 * c3.b - 1.0, 1.0), 0.0)), c3.a);
    c4 = texture2D(supTex4, textureCoordinate);
    color.rgb = mix(color.rgb, min(c4.rgb, color.rgb), c4.a);
    gl_FragColor = color;
}
