varying highp vec2 textureCoordinate;
precision highp float;
uniform sampler2D videoFrame;
uniform sampler2D supTex1;
uniform sampler2D supTex2;
uniform sampler2D supTex3;
uniform sampler2D supTex4;
uniform sampler2D supTex5;

vec3 colorsCorrection(vec3 base) {
    highp vec2 lookup;
    base.r = base.r * 0.95 + 0.025;
    lookup.y = base.g;
    lookup.x = (base.r + floor(base.b * 15.0 + 0.50)) / 16.0;
    base.rgb = texture2D(supTex1, lookup).rgb;
    return base;
}

void main() {
    highp vec4 color;
    highp vec4 c2;
    highp vec4 c3;
    highp vec4 c4;
    highp vec4 c5;
    color = texture2D(videoFrame, textureCoordinate);
    color.rgb = colorsCorrection(color.rgb);
    c2 = texture2D(supTex2, textureCoordinate);
    color.rgb = mix(color.rgb, vec3((c2.r < 0.5 ? (2.0 * c2.r * color.r) : (1.0 - 2.0 * (1.0 - c2.r) * (1.0 - color.r))), (c2.g < 0.5 ? (2.0 * c2.g * color.g) : (1.0 - 2.0 * (1.0 - c2.g) * (1.0 - color.g))), (c2.b < 0.5 ? (2.0 * c2.b * color.b) : (1.0 - 2.0 * (1.0 - c2.b) * (1.0 - color.b)))), c2.a);
    c3 = texture2D(supTex3, textureCoordinate);
    color.rgb = mix(color.rgb, vec3(max(min(color.r + 2.0 * c3.r - 1.0, 1.0), 0.0), max(min(color.g + 2.0 * c3.g - 1.0, 1.0), 0.0), max(min(color.b + 2.0 * c3.b - 1.0, 1.0), 0.0)), c3.a);
    c4 = texture2D(supTex4, textureCoordinate);
    color.rgb = mix(color.rgb, vec3(max(min(color.r + 2.0 * c4.r - 1.0, 1.0), 0.0), max(min(color.g + 2.0 * c4.g - 1.0, 1.0), 0.0), max(min(color.b + 2.0 * c4.b - 1.0, 1.0), 0.0)), c4.a);
    c5 = texture2D(supTex5, textureCoordinate);
    color.rgb = mix(color.rgb, vec3(((c5.r < 0.5) ? (((2.0 * c5.r) == 0.0) ? (2.0 * c5.r) : max((1.0 - ((1.0 - color.r) / (2.0 * c5.r))), 0.0)) : (((2.0 * (c5.r - 0.5)) == 1.0) ? (2.0 * (c5.r - 0.5)) : min(color.r / (1.0 - (2.0 * (c5.r - 0.5))), 1.0))), ((c5.g < 0.5) ? (((2.0 * c5.g) == 0.0) ? (2.0 * c5.g) : max((1.0 - ((1.0 - color.g) / (2.0 * c5.g))), 0.0)) : (((2.0 * (c5.g - 0.5)) == 1.0) ? (2.0 * (c5.g - 0.5)) : min(color.g / (1.0 - (2.0 * (c5.g - 0.5))), 1.0))), ((c5.b < 0.5) ? (((2.0 * c5.b) == 0.0) ? (2.0 * c5.b) : max((1.0 - ((1.0 - color.b) / (2.0 * c5.b))), 0.0)) : (((2.0 * (c5.b - 0.5)) == 1.0) ? (2.0 * (c5.b - 0.5)) : min(color.b / (1.0 - (2.0 * (c5.b - 0.5))), 1.0)))), c5.a);
    gl_FragColor = color;
}
