varying highp vec2 textureCoordinate;
precision highp float;
uniform sampler2D videoFrame;
uniform sampler2D supTex1;
uniform sampler2D supTex2;
uniform sampler2D supTex3;

vec3 colorsCorrection(vec3 base) {
    vec2 lookup;
    vec4 texel;
    texel = vec4(1.0);
    lookup.y = .5;
    lookup.x = base.r;
    texel.r = texture2D(supTex1, lookup).r;
    lookup.x = base.g;
    texel.g = texture2D(supTex1, lookup).g;
    lookup.x = base.b;
    texel.b = texture2D(supTex1, lookup).b;
    return texel.rgb;
}

void main() {
    vec4 base;
    vec4 blend;
    base = texture2D(videoFrame, textureCoordinate);
    base.rgb = colorsCorrection(base.rgb);
    blend = vec4(0.44705882352941, 0.37647058823529, 0.25098039215686, 0.42);

    base.r = ((blend.r < 0.5) ? (2.0 * base.r * blend.r + base.r * base.r * (1.0 - 2.0 * blend.r)) : (sqrt(base.r) * (2.0 * blend.r - 1.0) + 2.0 * base.r * (1.0 - blend.r)));
    base.g = ((blend.g < 0.5) ? (2.0 * base.g * blend.g + base.g * base.g * (1.0 - 2.0 * blend.g)) : (sqrt(base.g) * (2.0 * blend.g - 1.0) + 2.0 * base.g * (1.0 - blend.g)));
    base.b = ((blend.b < 0.5) ? (2.0 * base.b * blend.b + base.b * base.b * (1.0 - 2.0 * blend.b)) : (sqrt(base.b) * (2.0 * blend.b - 1.0) + 2.0 * base.b * (1.0 - blend.b)));

    blend = texture2D(supTex3, textureCoordinate);
    base.rgb = mix(base.rgb, vec3((base.r < 0.5 ? (2.0 * base.r * blend.r) : (1.0 - 2.0 * (1.0 - base.r) * (1.0 - blend.r))), (base.g < 0.5 ? (2.0 * base.g * blend.g) : (1.0 - 2.0 * (1.0 - base.g) * (1.0 - blend.g))), (base.b < 0.5 ? (2.0 * base.b * blend.b) : (1.0 - 2.0 * (1.0 - base.b) * (1.0 - blend.b)))), blend.a);
    blend = texture2D(supTex2, textureCoordinate);
    base.rgb = mix(base.rgb, blend.rgb, blend.a);
    gl_FragColor = base;
}