precision highp float;
uniform sampler2D videoFrame;
uniform float width;
varying highp vec2 textureCoordinate;
uniform vec4 faceRect;

void main() {
    highp vec4 base = texture2D(videoFrame, textureCoordinate);
    if (textureCoordinate.x >= faceRect.x && textureCoordinate.x <= faceRect.z && textureCoordinate.y >= faceRect.w && textureCoordinate.y <= faceRect.y) {
        base.rgb *= 17.0;
        float delta = 1.0 / width;
        base.rgb -= texture2D(videoFrame, textureCoordinate + vec2(-delta, -delta)).rgb;
        base.rgb -= texture2D(videoFrame, textureCoordinate + vec2(0.0, -delta)).rgb;
        base.rgb -= texture2D(videoFrame, textureCoordinate + vec2(delta, -delta)).rgb;
        base.rgb -= texture2D(videoFrame, textureCoordinate + vec2(-delta, 0.0)).rgb;
        base.rgb -= texture2D(videoFrame, textureCoordinate + vec2(delta, 0.0)).rgb;
        base.rgb -= texture2D(videoFrame, textureCoordinate + vec2(-delta, delta)).rgb;
        base.rgb -= texture2D(videoFrame, textureCoordinate + vec2(0.0, delta)).rgb;
        base.rgb -= texture2D(videoFrame, textureCoordinate + vec2(delta, delta)).rgb;
        base.rgb /= 9.0;
    }
    gl_FragColor = base;
}