precision highp float;
uniform sampler2D videoFrame;
uniform float width;
varying highp vec2 textureCoordinate;
uniform vec4 faceRect;

void main() {
    float lowerThreshold = 0.01372549019608;
    float upperThreshold = 0.04117647058824;
    float thresholdRange = 0.02745098039216;
    vec3 weightSqrt = vec3(0.546808924579693, 0.766159252375118, 0.337638860322683);

    highp vec4 base = texture2D(videoFrame, textureCoordinate);

    vec3 tmpSum = vec3(0.0);
    float count = 0.0;
    float w;
    if (textureCoordinate.x < faceRect.x || textureCoordinate.x > faceRect.z || textureCoordinate.y < faceRect.w || textureCoordinate.y > faceRect.y) {
        gl_FragColor = base;
    } else {
        for (float y = -10.0; y <= 10.0; y += 1.0) {
            float dx = 10.0 - abs(y);
            for (float x = -dx; x <= dx; x += 1.0) {
                vec3 tmp = texture2D(videoFrame, textureCoordinate + vec2(x / width, y / width)).rgb;
                float diff = length((tmp - base.rgb) * weightSqrt);
                if (diff <= upperThreshold) {
                     if (diff > lowerThreshold) {
                        w = (upperThreshold - diff) / thresholdRange;
                     } else {
                        w = 1.0;
                     }
                     tmpSum += tmp * w;
                     count += w;
                }
            }
        }
        tmpSum /= count;
        gl_FragColor = vec4(tmpSum, 1.0);
    }
}